//		Ti-Dos by Zaz alias Xavier de Boysson ver 0.1.80
#define SAVE_SCREEN										// saves &then restores screen at the end of the prg
#include <nostub.h>
#include <all.h>

int _ti89,_ti92plus;										// compile for both calcs

HANDLE handle = 0;										// sets the handler
char command[64] = "";										// where keyb inputs go to as strings
char oldcommand[64] = "";
int error = 1;
int numb = 0;
void progexec(char *name)									// execution of a program (help provided by Zeljko Juric)
{
	char filename[64];
	TRY
		strcpy (filename,name);
		strcat (filename,"()");
		push_parse_text (filename);
		handle = HS_popEStack();
		NG_execute (handle,FALSE);
		HeapFree (handle);
		error = 0;
	ONERR
		error = 1;
	ENDTRY
}

void InputCom (char *buffkey, int maxlen)							// better routine than gets from stdio.h (allows backspace etc...)
{
	SCR_STATE scrstat;
	int key, i = 0;
	buffkey[0] = 0;
	SaveScrState (&scrstat);
	do {
		MoveTo (scrstat.CurX, scrstat.CurY);
		printf ("%s   ", buffkey);

		key = GKeyIn( NULL, 0);
		ST_busy (ST_CLEAR);

		if (key == 264)									//esc key
			exit(0);
		if (key == 277)									// home key
			off();

		if (key == 270)									// home key
		{
			for (numb = 0 ; numb < strlen (oldcommand) ; numb++)
			{
				buffkey[i++];
				MoveTo (scrstat.CurX, scrstat.CurY);
				printf ("%s", oldcommand);
				strcpy (command, oldcommand);
				
			}
		}

		if (key >= ' ' && key <= '~' && i < maxlen)					// if key is valid then put char in
			buffkey[i++] = key;
		if (key == 257 && i)								// backspace key
			i--;

		buffkey[i] = 0;
	} while (key != 13);
	printf("\n");
}

int _main(void)
{
	char Cnamestr[64];									// C version of string (name of current folder)
	char TIOSname[64];									// is the TiOS version of the C string (necessary)
	char currfold[64];									// name of current folder
	char * namestr;
	char * srcname;										// name of source file
	char * dstname;										// name of destination file
	HANDLE handle = 0;									// resets the handler
	FolderAdd ($(root));									// creates folder root
	FolderCur ($(root),FALSE);								// sets root as current dir
	clrscr ();										// clears screen and resets pen position
	while(1)
	{
		FontSetSys (F_4x6);								// sets small font size
		FolderGetCur (currfold);							// gets current fold into currfold
		if (strcmp (currfold,"root") == 0)
			printf ("%s","C:\\>");							// the root folder is C:\>
		else
			printf ("%s%s%s","C:\\",currfold,">");					// C:\Current folder name>
		InputCom (command,64);								// launches the above function (InputCom)
		strcpy (oldcommand, command);
		printf ("%s", "");
		#include "functions.c"								// runs functions.c

	}
}
